#include <stdlib.h>
#include <assert.h>

#include "matrix.h"

/* Vytvo matici NxM */
Matrix *matrix_create(int rows, int cols){
	Matrix *tmp = malloc(sizeof(Matrix));

	if(tmp == NULL){
		return NULL;
	}
	assert(tmp);
	tmp->cols = cols;
	tmp->rows = rows;
	tmp->data = malloc(sizeof(double) * cols * rows);

	if (tmp->data == NULL){
		free(tmp);
		return NULL;
	}
	assert(tmp);
	/* Nastaven vech hodnot matice na 0 */
	int i;
	for(i=0;i<cols*rows; i++){
		tmp->data[i] = 0;
	}
	
	return tmp;
}

/* Vytiskne celou matici */
void matrix_print(Matrix *matrix){
	assert(matrix);
	int i;
	for(i=0; i < (matrix->cols * matrix->rows); i++){
		printf("%f, ",matrix->data[i]);
		if(i%matrix->rows == 0)
			printf("\n");
	}
}

/* Uvoln pam pouitou pro matici */
void matrix_free(Matrix **matrix){
	assert(*matrix);
	free((*matrix)->data);
	free(*matrix);
	*matrix = NULL;	
}

void matrix_set(Matrix *m, int row, int col, double val){
	assert(m);
	if((row > m->rows) || (col > m->cols))
		return;

	int position = col * m->rows + row;

	m->data[position] = val;
	/* nebo pomoc poiter */
	/* *(m->data + position) = val; */
}

double matrix_get(Matrix *m, int row, int col){
	assert(m);
	if((row > m->rows) || (col > m->cols))
		return;

	int position = col * m->rows + row;
	return m->data[position];
}
